﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;

namespace cxyLib
{
    /// <summary>
    /// 网页源代码下载器
    /// </summary>
    public class HttpDownLoader
    {
        private string webCoding;//网页编码



        public HttpDownLoader(string _webCoding)
        {
            webCoding = _webCoding;
        }

        public string HttpGet(string _uri)
        {
            return HttpGet(_uri, "", "");
        }



        public string HttpGet(string uri, string username, string password)
        {
            Stream stream;
            String response = null;
            WebClient webClient = new WebClient();

            using (webClient)
            {
                // Check our auth details
                if (!string.IsNullOrEmpty(username) && !string.IsNullOrEmpty(password))
                {
                    webClient.Credentials = new NetworkCredential(username, password);
                }

                try
                {
                    // open and read from the supplied URI
                    stream = webClient.OpenRead(uri);
                    StreamReader smr = new StreamReader(stream, Encoding.GetEncoding(webCoding));

                    response = smr.ReadToEnd();
                    return response;


                }
                catch (WebException ex)
                {
                    if (ex.Response is HttpWebResponse)
                    {
                        // Add you own error handling as required
                        switch (((HttpWebResponse)ex.Response).StatusCode)
                        {
                            case HttpStatusCode.NotFound:
                            case HttpStatusCode.Unauthorized:
                                response = null;
                                break;

                            default:
                                throw ex;
                        }
                    }
                }
            }

            return response;
        }
    }
}
