﻿using System;
using System.Net;
using System.IO;

namespace cxyLib
{
  public  class ImageDownLoader
    {
        /// <summary>
        /// 下载文件链接地址
        /// </summary>
        public string downFileUrl = "";


        /// <summary>
        /// 保存路劲
        /// </summary>
        public string savePath = "";
      /// <summary>
      /// 下载文件
      /// </summary>
      /// <param name="_downFileUrl">文件地址</param>
      /// <param name="_savePath">文件保存路径</param>
      /// <returns>返回结果</returns>
        public bool DownLoadImage( string _downFileUrl,string _savePath )
        {
            try
            {
                string savePath = _savePath;
                string downFileUrl = _downFileUrl ;//下载文件链接地址
                WebClient wcClient = new WebClient();
                WebRequest webReq = WebRequest.Create(downFileUrl);
                WebResponse webRes = webReq.GetResponse();
                long fileLength = webRes.ContentLength;

                Stream srm = webRes.GetResponseStream();
                StreamReader srmReader = new StreamReader(srm);
                byte[] bufferbyte = new byte[fileLength];
                int allByte = (int)bufferbyte.Length;
                int startByte = 0;
                while (fileLength > 0)
                {
                    //Application.DoEvents();
                    int downByte = srm.Read(bufferbyte, startByte, allByte);
                    if (downByte == 0) { break; };
                    startByte += downByte;
                    allByte -= downByte;
                }
                if (File.Exists(savePath))
                {
                    
                  // savePath = savePath + "_" +  new Random().Next(0, 1000).ToString();
                    savePath = savePath.Replace(",", new Random().Next(0, 1000).ToString() + "."); //给文件从新命名
                      
                }

                if (!File.Exists(savePath))
                {
                    string[] dirArray = savePath.Split('\\');
                    string temp = string.Empty;
                    for (int i = 0; i < dirArray.Length - 1; i++)
                    {
                        temp += dirArray[i].Trim() + "\\";
                        if (!Directory.Exists(temp))
                            Directory.CreateDirectory(temp);
                    }
                }
                FileStream fs = new FileStream(savePath, FileMode.OpenOrCreate, FileAccess.Write);
                fs.Write(bufferbyte, 0, bufferbyte.Length);
                srm.Close();
                srmReader.Close();
                fs.Close();
                return true;
            }
            catch (WebException ex)
            {
                throw ex;
                return false;
            }
        }
    }
}
