﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;

namespace cxyLib
{
    public class LinkOleDb : ILinkDbBase
    {
        private OleDbConnection _connection;
        private OleDbCommand _comm;

        public LinkOleDb()
        {
            _connection = null;
        }

        #region Implementation of ILinkDbBase


        public void Connect(string connStr)
        {

            if (_connection != null)
            {
                _connection.Close();
            }
            else
            {
                try
                {
                    _connection = new OleDbConnection(connStr);
                    _connection.Open();
                }
                catch (OleDbException dbException)
                {
                    MessageBox.Show(dbException.StackTrace);
                }

            }

        }
        /// <summary>
        /// 返回数据库所用的格式
        /// </summary>
        /// <returns></returns>
        public string GetConStrFormat()
        {
            return @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0};Persist Security Info=False";

        }

        public void GetDatabases(ComboBox databaseList)
        {
            throw new NotImplementedException("oledb不支持当前这个方法");
        }

        public void GetTables(string databaseName, ComboBox tables)
        {

            string _qsql = "select   id,  name   from msysobjects   where     flags=0     and     type=1";

            if (_comm == null)
                _comm = new OleDbCommand(_qsql, _connection);
            _comm.CommandType = CommandType.Text;

            OleDbDataReader _reader = _comm.ExecuteReader(CommandBehavior.CloseConnection);

            while (_reader.Read())
            {
                tables.Items.Add((_reader.GetString(1)));
            }

        }

        /// <summary>
        /// 取出表中所有数据
        /// </summary>
        /// <param name="tablesname">表名</param>
        /// <returns></returns>
        public DataTable GetTablesData(string tablesname)
        {

            DataTable dt = new DataTable();
            if (_comm == null)
                _comm = new OleDbCommand("select * from "+tablesname, _connection);
            OleDbDataAdapter olda = new OleDbDataAdapter();
            olda.SelectCommand = _comm;

            olda.Fill(dt);
            return dt;
             
        }

        public void UpdateData(DataTable dt)
        {
            throw new NotImplementedException();
        }

        public int ExecuteNonQuery(string queryString)
        {

            if (_comm == null)
                _comm = new OleDbCommand(queryString, _connection);

            int queryres = 0;

            try
            {
                queryres = _comm.ExecuteNonQuery();
            }
            catch (OleDbException oleex)
            {

                MessageBox.Show(oleex.StackTrace);
            }

            return queryres;
            
             
        }

        public IDataReader ExecuteReader(string queryString)
        {


            if (_comm == null)
                _comm = new OleDbCommand(queryString, _connection);
            IDataReader reader = null;
            try
            {
                _connection.Open();


                reader = _comm.ExecuteReader(CommandBehavior.CloseConnection);

            }
            catch (OleDbException oleex)
            {
                MessageBox.Show(oleex.StackTrace);
            }

            return reader;
        }

        #endregion
    }



}